//<c>   Copyright 1996-1999 by Gerry J. Danen; all rights reserved.

//<t>   Change "Preferred Server" in NET.CFG and SHELL.CFG

//      Compiled with Microsoft C 8.00. Requires DANEN library to recompile.
//      Source released into the Public Domain.

//      Syntax: PFSERVER from_name to_name file_with_filenames

//      Changes lines that contain:
//            PREFERRED SERVER = ADMIN
//      PREFERRED SERVER=ADMIN


#include"gd_tools.h"


#define pgVERS_ "V3.00"
#define pgTITL_ "Change \"Preferred Server\" in NET.CFG and SHELL.CFG"
#define pgCOPR_ "1996"


#define BUFSIZE 10000
UCHAR   work[BUFSIZE+2], work1[BUFSIZE+2], *w ; // file buffers
UCHAR   PSfrom[41], PSto[41] ;                  // server names
UCHAR   iFile[FS_LEN], oFile[FS_LEN],
        nFile[FS_LEN], bakFile[FS_LEN] ;        // file names
FILE    *oFh, *iFh, *nFh, *bakFh ;              // file handles


void    show_help( void )
{
    logon(1);
    printf( "\nSyntax:  %s from_name to_name file_with_filenames\n\n"
            "\t from_name    old \"preferred server\" name\n"
            "\t to_name      new \"preferred server\" name\n"
            "\t file_with... file with names of net.cfg and shell.cfg files\n\n",
            get_global_program_name() );
    exit( GD_ERROR_HELP );
}


void    process_file( STRING fName )
{
    BOOL        ynPSfound, ynChanged ;

    ynPSfound = ynChanged = FALSE ;

    st_cpy( iFile, fName, FS_LEN );             // copy and fix the file name
    st_trim( iFile );
    strupr ( iFile );
    if ( ! strlen(iFile) )
        return ;
    printf( "%25s ... ", iFile );
    if ( ! fl_exist( iFile ) )                  // if not found, we're done
    {
        printf( "config file not found\n" );
        return ;
    }

    strcpy( bakFile, iFile );                   // create .bak file name
    w = strchr( bakFile, '.' );
    if ( w != NULL )
        *w = EOS ;
    strcat( bakFile, ".BAK" );

    // process from .BAK -> .CFG <---

    fl_delete( bakFile );
    fl_rename( iFile, bakFile );                // save a copy of the file
    if ( ( bakFh = fopen( bakFile, "r" ) ) == NULL )
    {
        printf( "could not open %s backup file\n", bakFile );
        return ;
    }
    iFh = fl_create_or_replace_tty( iFh, iFile, "w", YES, NO ); // create new .cfg file

    while ( (w = fgets( work, BUFSIZE, bakFh )) )
    {
        st_rtrim( work );                       // remove trailing spaces & \n
        StrDetab( work1, work, BUFSIZE );       // detab
        strcpy( work, work1 );                  // analyze what we have in "work"
        st_remove_spaces( work );               // remove all spaces--easier to compare things
        w = strchr( work, '=' );
        if ( w )                                // does the line contain a "=" ?
        {
            *w = EOS ;
            w ++ ;
            if ( st_eq(work, "PreferredServer") )
            {
                ynPSfound = TRUE ;              // found a PREFERRED SERVER entry
                if ( st_eq(w, PSfrom) )         // .. and it's a match !
                {
                    work1[strlen(work1)-strlen(PSfrom)] = EOS ;
                    strcat( work1, PSto );
                    ynChanged = TRUE ;
                }
            }
        }
        fprintf( iFh, "%s\n", work1 );            // write line
    }

    fclose( bakFh );
    fclose(   iFh );

    if ( ynPSfound )
    {
        printf( "Preferred Server " );
        if ( ynChanged )
            printf( "changed to %s\n", PSto );
        else
            printf( "not changed\n" );
    }
    else
        printf( "No Preferred Server\n" );
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 4 )
        show_help();

    st_cpy( PSfrom, (UCHAR *) argv[1], 41 );    // Preferred Server "from"
    st_cpy( PSto  , (UCHAR *) argv[2], 41 );    // Preferred Server "to"
    st_cpy( nFile , (UCHAR *) argv[3], FS_LEN );// file with filenames
    strupr( PSfrom );
    strupr( PSto   );
    strupr( nFile  );

    if ( ( nFh = fopen( nFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", nFile );
        show_help();
    }

    printf( "\nChanging Preferred Server from %s to %s\n\n", PSfrom, PSto );
    while ( (w = fgets( work, BUFSIZE, nFh )) )
    {
        process_file( work );
    }
    fcloseall();
    printf( "\n" );

    exit( GD_ERROR_NONE );
}
